# coding: utf-8

"""
    Secore API

    API for the Seres core platform

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from datetime import datetime
from pydantic import Field, StrictInt
from typing import List, Optional
from typing_extensions import Annotated
from seres_client.models.available_resource_assembly_schema_schema import AvailableResourceAssemblySchemaSchema

from seres_client.api_client import ApiClient, RequestSerialized
from seres_client.api_response import ApiResponse
from seres_client.rest import RESTResponseType


class AvailableResourceAssembliesApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def get_available_assemblies(
        self,
        from_datetime: Optional[datetime] = None,
        to_datetime: Optional[datetime] = None,
        port_id: Optional[StrictInt] = None,
        subnet_id: Optional[StrictInt] = None,
        resource_group_id: Optional[StrictInt] = None,
        resource_assembly_schema_id: Optional[StrictInt] = None,
        future_id: Annotated[Optional[StrictInt], Field(description="Operate in the context of the timeline where this future is the head.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> List[AvailableResourceAssemblySchemaSchema]:
        """Get Available Assemblies

        List available resource assemblies

        :param from_datetime:
        :type from_datetime: datetime
        :param to_datetime:
        :type to_datetime: datetime
        :param port_id:
        :type port_id: int
        :param subnet_id:
        :type subnet_id: int
        :param resource_group_id:
        :type resource_group_id: int
        :param resource_assembly_schema_id:
        :type resource_assembly_schema_id: int
        :param future_id: Operate in the context of the timeline where this future is the head.
        :type future_id: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_available_assemblies_serialize(
            from_datetime=from_datetime,
            to_datetime=to_datetime,
            port_id=port_id,
            subnet_id=subnet_id,
            resource_group_id=resource_group_id,
            resource_assembly_schema_id=resource_assembly_schema_id,
            future_id=future_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "List[AvailableResourceAssemblySchemaSchema]",
            '401': None,
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def get_available_assemblies_with_http_info(
        self,
        from_datetime: Optional[datetime] = None,
        to_datetime: Optional[datetime] = None,
        port_id: Optional[StrictInt] = None,
        subnet_id: Optional[StrictInt] = None,
        resource_group_id: Optional[StrictInt] = None,
        resource_assembly_schema_id: Optional[StrictInt] = None,
        future_id: Annotated[Optional[StrictInt], Field(description="Operate in the context of the timeline where this future is the head.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[List[AvailableResourceAssemblySchemaSchema]]:
        """Get Available Assemblies

        List available resource assemblies

        :param from_datetime:
        :type from_datetime: datetime
        :param to_datetime:
        :type to_datetime: datetime
        :param port_id:
        :type port_id: int
        :param subnet_id:
        :type subnet_id: int
        :param resource_group_id:
        :type resource_group_id: int
        :param resource_assembly_schema_id:
        :type resource_assembly_schema_id: int
        :param future_id: Operate in the context of the timeline where this future is the head.
        :type future_id: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_available_assemblies_serialize(
            from_datetime=from_datetime,
            to_datetime=to_datetime,
            port_id=port_id,
            subnet_id=subnet_id,
            resource_group_id=resource_group_id,
            resource_assembly_schema_id=resource_assembly_schema_id,
            future_id=future_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "List[AvailableResourceAssemblySchemaSchema]",
            '401': None,
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def get_available_assemblies_without_preload_content(
        self,
        from_datetime: Optional[datetime] = None,
        to_datetime: Optional[datetime] = None,
        port_id: Optional[StrictInt] = None,
        subnet_id: Optional[StrictInt] = None,
        resource_group_id: Optional[StrictInt] = None,
        resource_assembly_schema_id: Optional[StrictInt] = None,
        future_id: Annotated[Optional[StrictInt], Field(description="Operate in the context of the timeline where this future is the head.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Get Available Assemblies

        List available resource assemblies

        :param from_datetime:
        :type from_datetime: datetime
        :param to_datetime:
        :type to_datetime: datetime
        :param port_id:
        :type port_id: int
        :param subnet_id:
        :type subnet_id: int
        :param resource_group_id:
        :type resource_group_id: int
        :param resource_assembly_schema_id:
        :type resource_assembly_schema_id: int
        :param future_id: Operate in the context of the timeline where this future is the head.
        :type future_id: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_available_assemblies_serialize(
            from_datetime=from_datetime,
            to_datetime=to_datetime,
            port_id=port_id,
            subnet_id=subnet_id,
            resource_group_id=resource_group_id,
            resource_assembly_schema_id=resource_assembly_schema_id,
            future_id=future_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "List[AvailableResourceAssemblySchemaSchema]",
            '401': None,
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _get_available_assemblies_serialize(
        self,
        from_datetime,
        to_datetime,
        port_id,
        subnet_id,
        resource_group_id,
        resource_assembly_schema_id,
        future_id,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if from_datetime is not None:
            if isinstance(from_datetime, datetime):
                _query_params.append(
                    (
                        'from_datetime',
                        from_datetime.strftime(
                            self.api_client.configuration.datetime_format
                        )
                    )
                )
            else:
                _query_params.append(('from_datetime', from_datetime))
            
        if to_datetime is not None:
            if isinstance(to_datetime, datetime):
                _query_params.append(
                    (
                        'to_datetime',
                        to_datetime.strftime(
                            self.api_client.configuration.datetime_format
                        )
                    )
                )
            else:
                _query_params.append(('to_datetime', to_datetime))
            
        if port_id is not None:
            
            _query_params.append(('port_id', port_id))
            
        if subnet_id is not None:
            
            _query_params.append(('subnet_id', subnet_id))
            
        if resource_group_id is not None:
            
            _query_params.append(('resource_group_id', resource_group_id))
            
        if resource_assembly_schema_id is not None:
            
            _query_params.append(('resource_assembly_schema_id', resource_assembly_schema_id))
            
        # process the header parameters
        if future_id is not None:
            _header_params['future-id'] = future_id
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'APIKeyHeader', 
            'APIKeyCookie'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/api/available-resource-assemblies',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )


