# coding: utf-8

"""
    Secore API

    API for the Seres core platform

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List
from seres_client.models.available_resource_assembly_schema_component_resource_schema_action_schema import AvailableResourceAssemblySchemaComponentResourceSchemaActionSchema
from seres_client.models.configuration_enum import ConfigurationEnum
from seres_client.models.resource_type_enum import ResourceTypeEnum
from typing import Optional, Set
from typing_extensions import Self

class AvailableResourceAssemblySchemaComponentSchema(BaseModel):
    """
    AvailableResourceAssemblySchemaComponentSchema
    """ # noqa: E501
    type: ResourceTypeEnum
    resource_assembly_schema_component_id: StrictInt
    resource_id: StrictInt
    resource_schema_id: StrictInt
    is_primary: StrictBool
    configuration: ConfigurationEnum
    resource_schema_actions: List[AvailableResourceAssemblySchemaComponentResourceSchemaActionSchema]
    __properties: ClassVar[List[str]] = ["type", "resource_assembly_schema_component_id", "resource_id", "resource_schema_id", "is_primary", "configuration", "resource_schema_actions"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AvailableResourceAssemblySchemaComponentSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in resource_schema_actions (list)
        _items = []
        if self.resource_schema_actions:
            for _item_resource_schema_actions in self.resource_schema_actions:
                if _item_resource_schema_actions:
                    _items.append(_item_resource_schema_actions.to_dict())
            _dict['resource_schema_actions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AvailableResourceAssemblySchemaComponentSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "resource_assembly_schema_component_id": obj.get("resource_assembly_schema_component_id"),
            "resource_id": obj.get("resource_id"),
            "resource_schema_id": obj.get("resource_schema_id"),
            "is_primary": obj.get("is_primary"),
            "configuration": obj.get("configuration"),
            "resource_schema_actions": [AvailableResourceAssemblySchemaComponentResourceSchemaActionSchema.from_dict(_item) for _item in obj["resource_schema_actions"]] if obj.get("resource_schema_actions") is not None else None
        })
        return _obj


