# coding: utf-8

"""
    Secore API

    API for the Seres core platform

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from seres_client.models.future_activity_type import FutureActivityType
from seres_client.models.future_entity_type import FutureEntityType
from typing import Optional, Set
from typing_extensions import Self

class FutureActivitySchema(BaseModel):
    """
    FutureActivitySchema
    """ # noqa: E501
    id: StrictInt
    created: StrictStr
    type: FutureActivityType
    account_id: StrictInt
    created_by_id: StrictInt
    future_id: StrictInt
    committed: StrictBool
    future_entity_id: StrictInt
    future_entity_type: FutureEntityType
    parent_future_entity_id: Optional[StrictInt] = None
    parent_future_entity_type: Optional[FutureEntityType] = None
    grandparent_future_entity_id: Optional[StrictInt] = None
    grandparent_future_entity_type: Optional[FutureEntityType] = None
    related_resource_id: Optional[StrictInt] = None
    __properties: ClassVar[List[str]] = ["id", "created", "type", "account_id", "created_by_id", "future_id", "committed", "future_entity_id", "future_entity_type", "parent_future_entity_id", "parent_future_entity_type", "grandparent_future_entity_id", "grandparent_future_entity_type", "related_resource_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FutureActivitySchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if parent_future_entity_id (nullable) is None
        # and model_fields_set contains the field
        if self.parent_future_entity_id is None and "parent_future_entity_id" in self.model_fields_set:
            _dict['parent_future_entity_id'] = None

        # set to None if parent_future_entity_type (nullable) is None
        # and model_fields_set contains the field
        if self.parent_future_entity_type is None and "parent_future_entity_type" in self.model_fields_set:
            _dict['parent_future_entity_type'] = None

        # set to None if grandparent_future_entity_id (nullable) is None
        # and model_fields_set contains the field
        if self.grandparent_future_entity_id is None and "grandparent_future_entity_id" in self.model_fields_set:
            _dict['grandparent_future_entity_id'] = None

        # set to None if grandparent_future_entity_type (nullable) is None
        # and model_fields_set contains the field
        if self.grandparent_future_entity_type is None and "grandparent_future_entity_type" in self.model_fields_set:
            _dict['grandparent_future_entity_type'] = None

        # set to None if related_resource_id (nullable) is None
        # and model_fields_set contains the field
        if self.related_resource_id is None and "related_resource_id" in self.model_fields_set:
            _dict['related_resource_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FutureActivitySchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "created": obj.get("created"),
            "type": obj.get("type"),
            "account_id": obj.get("account_id"),
            "created_by_id": obj.get("created_by_id"),
            "future_id": obj.get("future_id"),
            "committed": obj.get("committed"),
            "future_entity_id": obj.get("future_entity_id"),
            "future_entity_type": obj.get("future_entity_type"),
            "parent_future_entity_id": obj.get("parent_future_entity_id"),
            "parent_future_entity_type": obj.get("parent_future_entity_type"),
            "grandparent_future_entity_id": obj.get("grandparent_future_entity_id"),
            "grandparent_future_entity_type": obj.get("grandparent_future_entity_type"),
            "related_resource_id": obj.get("related_resource_id")
        })
        return _obj


